#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>

typedef struct {
   char name[11],color;
   double zp;
} WFIRSTfilttype;

int WFIRST_NFILTERS=-1;
WFIRSTfilttype *WFIRSTfilters;

static void readdata(void) {
   int i;
   FILE *f;
   char str[1025];
   double eecorr;

   sprintf(str,"%s/wfirst/data/filters.dat",BASEDIR);
   if ((f=fopen(str,"r"))==NULL) {
      printf("Could not find %s\n",str);
      exit(0);
   }
   fscanf(f,"%d",&WFIRST_NFILTERS);
   fgets(str,81,f);
   WFIRSTfilters=(WFIRSTfilttype*)calloc(sizeof(WFIRSTfilttype),WFIRST_NFILTERS);
   assert(WFIRSTfilters!=NULL);
   for (i=0;i<WFIRST_NFILTERS;i++) {
      fgets(WFIRSTfilters[i].name,11,f); WFIRSTfilters[i].name[strlen(WFIRSTfilters[i].name)-1]=0;
      WFIRSTfilters[i].color=fgetc(f);
      fgets(str,81,f);
      fscanf(f,"%lf",&WFIRSTfilters[i].zp);
      fscanf(f,"%lf",&eecorr);
      fgets(str,81,f);
      //applying encircled energy correction afterwards since .xform is differential;
      WFIRSTfilters[i].zp-=eecorr;
   }
   fclose(f);
   return;
}

int WFIRSTfindfilt(char*str) {
   int i;
   void WFIRSTinitfilters();
   if (WFIRST_NFILTERS<0) WFIRSTinitfilters();
   for (i=0;i<WFIRST_NFILTERS;i++) if (!strcmp(WFIRSTfilters[i].name,str)) return i;
   printf("Illegal filter %s\n",str);
   exit(0);
   return -1;
}

void WFIRSTinitfilters(void) {
   readdata();
   return;
}

void WFIRSTtransform(double vmag[],double dvmag[],double smag[]) {
   int f;
   if (WFIRST_NFILTERS<0) WFIRSTinitfilters();
   for (f=0;f<WFIRST_NFILTERS;f++) smag[f]=99.999;
}

double WFIRSTuntransform(int filt,double smag[5]) {
   return 99999.;
}
