//extern int WFIRST_DRIZZLE_BASE;

//vmag: VEGA magnitudes;
//smag: UBVRI magnitudes;

//correct distortion;
extern void WFIRSTshift(int img,double*x,double*y);

//add distortion;
extern void WFIRSTunshift(int img,double*x,double*y);

//transforms, returns values in smag[];
extern void WFIRSTtransform(double vmag[],double dvmag[],double smag[]);

//returns VEGAMAG;
//extern double untransform(int cm,int filt,double smag[]);

//set parameters needed for WFIRST;
extern void wfirstinitparam(void);

//initialize PSF libraries;
extern void wfirstinitpsf(void);

//dispose PSF libraries;
extern void wfirstfreepsf(void);

//calculate PSF from WFIRST library;
extern int calcwfirstpsf(int img,float x,float y,int r,int force);

//do hotometric transformations, and output mag only;
extern double WFIRSTcalcmag(int img,float x0,float y0,float ct0);

//do photometric transformations, and output;
extern void WFIRSToutstar(FILE*,float x,float y,photdatatype*);
extern void WFIRSToutstarimg(int img,FILE*,float x,float y,photdatatype*);

//output column headers and image descriptions
extern void WFIRSToutstarinfo(FILE*,int*ct);
extern char *WFIRSTimagestring(int img);

//aperture correction radius (10 pixels)
extern float wfirst_apsize(int img,float x,float y);

//put lines in .info file;
extern void writewfirstinfo(void);

//correct counts in fake stars;
extern void WFIRSTreadfakemag(FILE*);
extern void WFIRSTfixfakemag(int img,float x0,float y0,double*ct0);
