#include <dolphot.h>
#include "wfirstpsfdata.h"

void usage(char *exe) {
   printf("Usage: %s <filt> <Xpos> <Ypos> <dX> <dY> <<flags>>\n",exe);
   exit(-1);
}

int main(int argc,char**argv) {
   int x,y,fx,fy,j,k,l,m,n;
   FILE *fpsf;
   char str[161];
   float **psf;

   if (argc!=6) usage(*argv);
   x=atoi(argv[2]);
   if (x<0 || x>=wfirst_nxpsfpos) {
      printf("X position must be 0-%d\n",wfirst_nxpsfpos-1);
      return -1;
   }
   y=atoi(argv[3]);
   if (y<0 || y>=wfirst_nypsfpos) {
      printf("Y position must be 0-%d\n",wfirst_nypsfpos-1);
      return -1;
   }
   fx=atoi(argv[4]);
   fy=atoi(argv[5]);
   if (fx<-wfirst_n2psf || fx>wfirst_n2psf || fy<-wfirst_n2psf || fy>wfirst_n2psf) {
      printf("dX and dY must be -%d to %d\n",wfirst_n2psf,wfirst_n2psf);
      return -1;
   }
   sprintf(str,"%s/wfirst/data/%s.%s.psf",BASEDIR,argv[1],wfirst_cn);
   if ((fpsf=fopen(str,"rb"))==NULL) {
      printf("Cannot open %s\n",str);
      return -1;
   }
   psf=(float**)calloc(sizeof(float*),wfirst_rpsf*2+1);
   if (!psf) merr();
   psf+=wfirst_rpsf;
   for (j=-wfirst_rpsf;j<=wfirst_rpsf;j++) {
      psf[j]=(float*)calloc(sizeof(float),wfirst_rpsf*2+1);
      if (!psf[j]) merr();
      psf[j]+=wfirst_rpsf;
   }
   for (j=0;j<y;j++) for (k=0;k<wfirst_nxpsfpos;k++) for (l=-wfirst_n2psf;l<=wfirst_n2psf;l++) for (m=-wfirst_n2psf;m<=wfirst_n2psf;m++) for (n=-wfirst_rpsf;n<=wfirst_rpsf;n++) fread(psf[n]-wfirst_rpsf,4,2*wfirst_rpsf+1,fpsf);
   for (k=0;k<x;k++) for (l=-wfirst_n2psf;l<=wfirst_n2psf;l++) for (m=-wfirst_n2psf;m<=wfirst_n2psf;m++) for (n=-wfirst_rpsf;n<=wfirst_rpsf;n++) fread(psf[n]-wfirst_rpsf,4,2*wfirst_rpsf+1,fpsf);
   for (l=-wfirst_n2psf;l<fy;l++) for (m=-wfirst_n2psf;m<=wfirst_n2psf;m++) for (n=-wfirst_rpsf;n<=wfirst_rpsf;n++) fread(psf[n]-wfirst_rpsf,4,2*wfirst_rpsf+1,fpsf);
   for (m=-wfirst_n2psf;m<fx;m++) for (n=-wfirst_rpsf;n<=wfirst_rpsf;n++) fread(psf[n]-wfirst_rpsf,4,2*wfirst_rpsf+1,fpsf);
   for (n=-wfirst_rpsf;n<=wfirst_rpsf;n++) ffread(psf[n]-wfirst_rpsf,4,2*wfirst_rpsf+1,fpsf);
   k=wfirst_rpsf;
   if (k>6) k=6;
   for (n=k;n>=-k;n--) {
      for (j=-k;j<=k;j++) printf("%5d ",(int)(psf[n][j]*100000+0.5));
      printf("\n");
   }
   fclose(fpsf);
   return 0;
}
